*" PACKAGE GAMKYN !" ưŪʥ ᥤ롼
*"                  ver 1.00             99/11/26 takepiro
***********************************************************************
      PROGRAM GAMKYN                         !" ᥤ롼
*
*"    Boussinesq 屿ưŪʥǥ
*"      one-level time integration
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [VAR]
      REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ
      REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
*"       : ɸ
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       ARAD  ( 0:KMAX )      !" ٥()
      REAL       DRAD  ( 0:KMAX )      !" ()
*
*"       : ֥ƥåץѥ᡼
      INTEGER    IT             !" 롼ץ
      CHARACTER  HINTG * (NCC)  !" ʬå
      LOGICAL    OOUT           !" ϥå
      LOGICAL    OEND           !" λå
      INTEGER    IUNIT          !" åֹ
      REAL       DELT           !" ֹ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
*
*
*" << SETPUP :  >>
*
      CALL GLPGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT, * ) ' 3-DIM KINEMATIC DYNAMO MODEL GAMKYN'
     &                   //NAME
     &                   //' ver.0.9, 99/11/26'
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL ATSTRT                      !" ¸()
     O     ( IT , DELT ) 
*
      CALL ACRGET                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL IHSTRT                      !" Ϥ
*
      CALL KIRRST                      !" ͤɤ߹ߤȺ
     O           ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I             IT    ,
     C             ALAT  , DLAT  , ARAD  , DRAD             )
*
      CALL ADMXMN 
     I         ( GBLON , GBLAT , GBRAD , 
     I           GBTOR , GBPOR , IT    , 'start GA' )
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 8888 CONTINUE
*
#ifdef DEBUG
      CALL ADMXMN 
     I         ( GBLON , GBLAT , GBRAD , 
     I           GBTOR , GBPOR , IT    , 'start GA' )
#endif
c$$$         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
*"        < 1. ֥ƥå >
*
          CALL ATSTEP               !"   
     M         ( IT   ,     
     O           HINTG , OOUT , OEND )
*
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL KDADMN                             !" ưŪʥ
     M         ( GBLON , GBLAT , GBRAD  , 
     M           GBTOR , GBPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL CLCEND ( 'DYNMCS' )
*
#ifdef DEBUG
*
         CALL ADMXMN 
     I         ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'start GA' )
         CALL KIWRST                       !" ꥹȥե񤭹
     I         ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR , IT )
#endif
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         IF ( OOUT ) THEN
            CALL KIWRST                    !" ꥹȥե񤭹
     I         ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR , IT )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. OEND ) GOTO 8888    !" << LEND : ᥤ󡦥롼׽ ****> >>
*
      CALL ADMXMN 
     I         ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , 'start GA' )

      CALL IHEND                       !" Ϥκǽ
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GBLON , GBLAT , GBRAD , GBTOR , GBPOR ,
     I           IT  , HLABEL  )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#endif
*
*   [INPUT] 
      REAL       GBLON ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, KDIM )  !" ưʬ
      REAL       GBTOR ( IDIM, JDIM, KDIM )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, KDIM )  !" ݥ뼧 B_P
*
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GBLON, IDIM, JDIM, KDIM, IDIM, JDIM, 'BLON' )
      CALL MAXMIN( GBLAT, IDIM, JDIM, KDIM, IDIM, JDIM, 'BLAT' )
      CALL MAXMIN( GBRAD, IDIM, JDIM, KDIM, IDIM, JDIM, 'BRAD' )
      CALL MAXMIN( GBTOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'BTOR' )
      CALL MAXMIN( GBPOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'BPOR' )
*
      RETURN
      END
