* PACKAGE KDADMN  !" ưŪʥ ᥤѡ
*"                  ver 0.1     99/11/25 (takepiro)
**********************************************************************
      SUBROUTINE KDADMN                      !" ưŪʥ
     M         ( GBLON , GBLAT , GBRAD , 
     M           GBTOR , GBPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*"      Runge-Kutta ʬ( ʿڥȥ - ľåɶ )
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [MODIFY]
      REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ
      REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KMAX )            !" ٥()
      REAL       DRAD  ( 0:KMAX )            !" ()
*"        : ɸʻ
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       PRNDM                       !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
*   [INTERNAL PARAM]
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    ONONLN                        !" ϳإå
      SAVE       ONONLN
*
*   [INTERNAL WORK]
      REAL       GDU( IDIM, JDIM, 0:KMAX )      !" ® u
      REAL       GDV( IDIM, JDIM, 0:KMAX )      !" ® v
      REAL       GDW( IDIM, JDIM, 0:KMAX )      !" ® w
*
*"       : ʻѲ­
*"       : Ѳ
*
      REAL       WDBTOR ( NMDIM , 0:KMAX    )  !" ȥ뼧 B_T
      REAL       WDBPOR ( NMDIM , 0:KMAX    )  !" ݥ뼧 B_P
      SAVE       WDBTOR , WDBPOR
*"       : ڥȥǡ
*
      REAL       WTBTOR ( NMDIM, 0:KMAX     )  !" ȥ뼧 B_T
      REAL       WTBPOR ( NMDIM, 0:KMAX     )  !" ݥ뼧 B_P
*"       : ڥȥѲ
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      INTEGER    IORUNG                        !" Runge-Kutta 
      PARAMETER( IORUNG = 4 )
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    KDPARM                     !" ѥ᥿
     O             ( PRNDM  , 
     O               ONONLN   )
*
         CALL G2W
     O         ( WDBTOR ,
     I           GBTOR ,
     I           '    ', 'POS ', KDIM )
*
         CALL G2W
     O         ( WDBPOR ,
     I           GBPOR ,
     I           '    ', 'POS ', KDIM )
*
      ENDIF
*
*" << Runge-Kutta Loop >>
*
      ITRUNG = 0
*
 8888 CONTINUE                    !" <---  Runge-Kutta Loop : 
        ITRUNG = ITRUNG + 1 
*
*" << TNDNCY : Ѳ >>
*
         IF( ONONLN )THEN
            CALL KDVEL          !"  ®پη׻ B -> v
     O         ( GDU   , GDV   , GDW   , 
     I           GBLON , GBLAT , GBRAD ,
     C           UVFACT, FLAPLA, 
     C           ARAD  , DRAD            )
*
            CALL KDGIND         !" ͶƳͶƳ (vB)
     O         ( WTBTOR, WTBPOR, 
     I           GBLON , GBLAT , GBRAD , 
     I           GDU   , GDV   , GDW   , 
     C           UVFACT, FLAPLA, 
     C           ARAD  , DRAD             )
*
        ELSE
           CALL RESET( WTBTOR , NMDIM*KDIM )
           CALL RESET( WTBPOR , NMDIM*KDIM )
        ENDIF
*
        CALL KDLIND             !" ͶƳ(Ȼ)
     M         ( WTBTOR , WTBPOR , 
     I           WDBTOR , WDBPOR , 
     C           PRNDM  , 
     C           FLAPLA , 
     C           ARAD   , DRAD      )
*
*" << INTGR : ʬ >>
*
        CALL KDTINT                !" ڥȥʬ
     M         ( WDBTOR , WDBPOR , 
     I           WTBTOR , WTBPOR , 
     I           DELT   , ITRUNG , 
     C           FLAPLA , NMO, 
     C           ARAD   , DRAD     )
*
        CALL KDGENG                !" ʻͤ
     O         ( GBLON  , GBLAT  , GBRAD ,
     O           GBTOR  , GBPOR  ,
     I           WDBTOR , WDBPOR , 
     C           FLAPLA , UVFACT , 
     C           ARAD   , DRAD            )
*
      IF ( ITRUNG . LT. IORUNG ) GOTO 8888  !" <--- Runge-Kutta Loop 
*
      CALL KIDIAG               !"  ǽ 
     I     ( IT    , 
     I       GBLON , GBLAT , GBRAD , 
     C       ALON  , DLON  , ALAT  , DLAT  , 
     C       ARAD  , DRAD                    )
*
      RETURN
*======================================================================
      ENTRY KDSTRT                      !" ǡκ
     O         ( GBLON , GBLAT , GBRAD   , 
     M           GBTOR , GBPOR ,
     C           ALAT  , DLAT  , 
     C           ARAD  , DRAD             )
*
*   [OUTNPUT]
*     REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ
*     REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ
*     REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ
*
*   [MODIFY]
*     REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
*     REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
      CALL KDSTRV                       !" ǡ
     O         ( GBLON , GBLAT , GBRAD , 
     M           GBTOR , GBPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD             ) 
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  KDPARM                        !" ѥ᥿
     O             ( PRNDM  , 
     O               ONONLN   )
*
      IMPLICIT NONE
*
*   [OUTPUT]
      REAL       PRNDM       !" ץɥ/СĿ/쥤Υ륺
      LOGICAL    ONONLN      !" ϳإå
*
*   [INTERNAL WORK]
      REAL       PRNDLM, SPRNDM !" ץɥ/СĿ/쥤Υ륺
      LOGICAL    NONLIN, SNONLN !" ϳإå
*
      NAMELIST    /NMMAG/  PRNDLM, NONLIN
*
      INTEGER    IFPAR, JFPAR

      LOGICAL    OFIRST
      DATA       OFIRST  / .TRUE.  /
*
      DATA       PRNDLM, NONLIN / 1.0, .TRUE. / 
      SAVE       SPRNDM, SNONLN, OFIRST
*
*"         < 1. NAMELIST ɤ߹ >
*
      IF ( OFIRST ) THEN
         OFIRST = .false.
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMMAG , END=1190 )
 1190    WRITE  ( JFPAR, NMMAG  )
*
         SPRNDM  = PRNDLM
         SNONLN  = NONLIN
      ENDIF
*
*"         < 2. ѥ᥿ν >
*
      PRNDM   = SPRNDM
      ONONLN  = SNONLN
*
      RETURN
      END
