* PACKAGE KDGDYN  !" ưŪʥ : ͶƳͶƳ()
*
*"  [HIS]  99/12/06(takepiro)
*
*********************************************************************
      SUBROUTINE KDVEL      !"  ®پη׻ B -> v
     O         ( GDU   , GDV   , GDW   , 
     I           GBLON , GBLAT , GBRAD ,
     C           UVFACT, FLAPLA, 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*   [PARAMETER]
#include        "zcdim.F"                    !" ʻȿ
*
*   [OUTPUT]
      REAL       GDU( IDIM, JDIM, KDIM )      !" ® u
      REAL       GDV( IDIM, JDIM, KDIM )      !" ® v
      REAL       GDW( IDIM, JDIM, KDIM )      !" ® w
*
*   [INPUT]
      REAL       GBLON ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBLAT ( IDIM, JDIM, KDIM )  !" ʬ
      REAL       GBRAD ( IDIM, JDIM, KDIM )  !" ưʬ
*
      REAL       UVFACT( IDIM*JDIM )         !" uU Υե
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
*
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( KDIM )              !" ٥()
      REAL       DRAD  ( KDIM )              !" ()
*
*   [INTERNAL WORK]
      INTEGER    I, J, K
*
*   [INTERNAL ONCE]
      INTEGER    IUNIT                       !" ɸֹ
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*"     < 0. ®پ > 
*
      IF ( OFIRST ) THEN
         CALL GLIGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT, * ) 
     &        ' DUMMY VELOCITY FOR KIN.DYNAMO:  DATE=99/12/07'
         OFIRST = .FALSE.
      ENDIF
*
      DO 1000 K=1,KDIM
         DO 1000 J=1,JDIM
            DO 1000 I=1,IDIM
               GDU( I, J, K ) = 0.0
               GDV( I, J, K ) = 0.0
               GDW( I, J, K ) = 0.0
 1000 CONTINUE 
*
      RETURN
      END
*********************************************************************
      SUBROUTINE KDGIND      !"  ͶƳͶƳ (vB)
     O         ( WTBTOR, WTBPOR, 
     I           GBLON , GBLAT , GBRAD , 
     I           GDU   , GDV   , GDW   , 
     C           UVFACT, FLAPLA, 
     C           ARAD  , DRAD             )
*
      IMPLICIT NONE
*
*   [PARAMETER]
#include        "zcdim.F"                   !" ʻȿ
*
*   [OUTPUT]
      REAL       WTBTOR ( NMDIM, KDIM )     !" ȥ뼧 B_T
      REAL       WTBPOR ( NMDIM, KDIM )     !" ݥ뼧 B_P
*
*   [INPUT]
      REAL       GBLON ( IDIM*JDIM*KDIM )   !" ʬ
      REAL       GBLAT ( IDIM*JDIM*KDIM )   !" ʬ
      REAL       GBRAD ( IDIM*JDIM*KDIM )   !" ưʬ
*
      REAL       GDU( IDIM*JDIM*KDIM )      !" ® u
      REAL       GDV( IDIM*JDIM*KDIM )      !" ® v
      REAL       GDW( IDIM*JDIM*KDIM )      !" ® w
*
      REAL       UVFACT( IDIM*JDIM )        !" uU Υե
      REAL       FLAPLA( NMDIM  )           !" ץ饷η
*
      REAL       ARAD  ( KDIM )             !" ٥()
      REAL       DRAD  ( KDIM )             !" ()
*
*   [INTERNAL WORK]
      REAL       GTBLON ( IDIM*JDIM*KDIM )  !" ʬͶƳ
      REAL       GTBLAT ( IDIM*JDIM*KDIM )  !" ʬͶƳ
      REAL       GTBRAD ( IDIM*JDIM*KDIM )  !" ưʬͶƳ
*
      REAL       ALPHA                      !" 
*
      INTEGER    IJK
*
*   [INTERNAL ONCE]
      INTEGER    IUNIT                       !" ɸֹ
      INTEGER    IFPAR, JFPAR
      LOGICAL    OFIRST
*
      NAMELIST   /NMALPH/ ALPHA
      DATA       ALPHA  / 0.0 /
      DATA       OFIRST / .TRUE. /
      SAVE       ALPHA, OFIRST
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL GLIGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT, * ) 
     &        ' INDUCTION TERM -- CONSTANT ALPHA EFFECT: DATE=99/12/07'
*
         CALL REWNML( IFPAR, JFPAR )
         READ ( IFPAR, NMALPH, END=1190 ) 
 1190    WRITE ( JFPAR, NMALPH ) 
      ENDIF
*
*"     < 1.  V  B > 
*
      DO 1000 IJK=1,IDIM*JDIM*KDIM
         GTBLON ( IJK ) =   GDV( IJK ) * GBRAD( IJK ) 
     &                    - GDW( IJK ) * GBLAT( IJK ) 
         GTBLAT ( IJK ) =   GDW( IJK ) * GBLON( IJK ) 
     &                    - GDU( IJK ) * GBRAD( IJK ) 
         GTBRAD ( IJK ) =   GDU( IJK ) * GBLAT( IJK ) 
     &                    - GDV( IJK ) * GBLON( IJK ) 
 1000 CONTINUE 
*
*"     < 2.   B > 
*
      DO 2000 IJK=1,IDIM*JDIM*KDIM
         GTBLON ( IJK ) =   GTBLON( IJK ) 
     &                      + ALPHA * GBLON( IJK ) 
         GTBLAT ( IJK ) =   GTBLAT( IJK ) 
     &                      + ALPHA * GBLAT( IJK ) 
         GTBRAD ( IJK ) =   GTBRAD( IJK ) 
     &                      + ALPHA * GBRAD( IJK ) 
 2000 CONTINUE 
*
*"     < 2.  ȥʬ   rߢ(v  B)/l(l+1) 
*"           ݥʬ   r(v  B)/l(l+1)      > 
*
      CALL G2WPOR           !" rߢv / l(l+1) ׻
     O     ( WTBTOR , 
     I       GTBLON , GTBLAT , GTBRAD ,
     F       'POS'  , 
     C       UVFACT , FLAPLA , 
     D       ARAD   , DRAD     )
*
      CALL G2WTOR           !" rv / l(l+1) ׻
     O     ( WTBPOR , 
     I       GTBLON , GTBLAT , 
     F       'POS'  , 
     C       UVFACT , FLAPLA , 
     D       ARAD   , DRAD     )
*
      RETURN
      END
