* PACKAGE KDADMN  !" ϳŪʥ ᥤѡ
*"                  ver 0.1     99/11/25 (takepiro)
**********************************************************************
      SUBROUTINE MHADMN                    !" ϳŪʥ
     M         ( GDU   , GDV   , GDW   , GDT   , 
     M           GDTOR , GDPOR ,
     M           GBLON , GBLAT , GBRAD , 
     M           GBTOR , GBPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*"      Runge-Kutta ʬ( ʿڥȥ - ľåɶ )
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zccom.F"                    !" ɸʪ
*
*   [MODIFY]
      REAL       GDU   ( IDIM, JDIM, 0:KMAX )  !" ® u
      REAL       GDV   ( IDIM, JDIM, 0:KMAX )  !" ® v
      REAL       GDW   ( IDIM, JDIM, 0:KMAX )  !" ® w
      REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
      REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !"    
*
      REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ B_lambda
      REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ B_phi
      REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ B_r
      REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
      REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KMAX )            !" ٥()
      REAL       DRAD  ( 0:KMAX )            !" ()
*"        : ɸʻ
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       RAYL                        !" 쥤꡼
      REAL       TAU                         !" ƥ顼
      REAL       PRND                        !" ץɥ
      REAL       PRNDM                       !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
*   [INTERNAL PARAM]
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    ONLDYN                !" ׻å(ư)
      LOGICAL    ONLTMP                !" ׻å(٤μ)
      LOGICAL    ONLIND                !" ׻å(ͶƳ)
      SAVE       ONLDYN,  ONLTMP,  ONLIND
*
*   [INTERNAL WORK]
*
*"       : ʻѲ­
*"       : Ѳ
      REAL       GTUA  ( IDIM, JDIM, 0:KMAX )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KMAX )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KMAX )  !" ľưѲ֣
*
*"       : ڥȥǡ
      REAL       WDTOR ( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KMAX     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KMAX     )  !" ݥ D_l 
*
      REAL       WDT   ( NMDIM , 0:KMAX     )  !"   
*
      REAL       WBTOR ( NMDIM , 0:KMAX    )  !" ȥ뼧 B_T
      REAL       WBPOR ( NMDIM , 0:KMAX    )  !" ݥ뼧 B_P
*
      SAVE       WDTOR , WDPOR , WDDPOR, WDT
      SAVE       WBTOR , WBPOR
*
*"       : ڥȥѲ
      REAL       WTDTOR ( NMDIM, 0:KMAX     )  !" ȥ 
      REAL       WTDPOR ( NMDIM, 0:KMAX     )  !" ݥ 
      REAL       WTDT   ( NMDIM, 0:KMAX     )  !"   
      REAL       WTBTOR ( NMDIM, 0:KMAX     )  !" ȥ뼧 B_T
      REAL       WTBPOR ( NMDIM, 0:KMAX     )  !" ݥ뼧 B_P
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      INTEGER    IORUNG                        !" Runge-Kutta 
      PARAMETER( IORUNG = 4 )
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    MHPARM                     !" ѥ᥿
     O             ( RAYL   , TAU    , PRND   , PRNDM  , 
     O               ONLDYN , ONLTMP , ONLIND           )
*
         CALL MHG2WD
     O         ( WDTOR , WDPOR , WDT  , WDDPOR ,
     O           WBTOR , WBPOR ,
     I           GDTOR , GDPOR , GDT  ,
     I           GBTOR , GBPOR ,
     C           FLAPLA,
     C           ARAD  , DRAD                     )
      ENDIF
*
*" << Runge-Kutta Loop >>
*
      ITRUNG = 0
*
 8888 CONTINUE                    !" <---  Runge-Kutta Loop : 
        ITRUNG = ITRUNG + 1 
*
*" << TNDNCY : Ѳ >>
*
*"        -----------------------< ư >
*
         IF( ONLDYN )THEN
            CALL MHGDYN         !"  ϳع vv - BB
     O         ( GTUA  , GTVA  , GTWA  ,
     I           GDU   , GDV   , GDW   , 
     I           GBLON , GBLAT , GBRAD , 
     C           UVFACT, 
     C           ALAT  , DLAT  , ARAD  , DRAD    )
         ELSE
            CALL RESET( GTUA , IDIM*JDIM*KDIM )
            CALL RESET( GTVA , IDIM*JDIM*KDIM )
            CALL RESET( GTWA , IDIM*JDIM*KDIM )
         ENDIF
*
         CALL GRDFRC            !" ϳس(ʻ)
     M         ( GTUA  , GTVA  , GTWA  , 
     C           ALON  , DLON  , ALAT  , DLAT ,
     C           ARAD  , DRAD                    )
*
*" ǧ
         CALL G2WTOR            !" ȥ : rv / l(l+1) 
     O        ( WTDTOR , 
     I          GTUA   , GTVA   , 
     F          'NEG'  , 
     C          UVFACT , FLAPLA , 
     D          ARAD   , DRAD     )
*
         CALL G2WPOR            !" ݥ : rߢv / l(l+1) 
     O        ( WTDPOR , 
     I          GTUA   , GTVA   , GTWA , 
     F          'POS'  , 
     C          UVFACT , FLAPLA , 
     D          ARAD   , DRAD     )
*
         CALL DLNDYN             !" ϳ 
     M         ( WTDTOR, WTDPOR, 
     I           WDTOR , WDPOR , WDT   , WDDPOR, 
     C           RAYL  , TAU   , PRND  , 
     C           NMO   , FLAPLA, 
     C           ARAD  , DRAD                    )
*
*"         -----------------------< Ǯ >
*
         IF( ONLTMP )THEN
            CALL VGRADS          !"  Ǯμή vT
     O         ( WTDT  ,
     I           GDU   , GDV   , GDW   , GDT   ,
     F           'NEG' , 
     C           UVFACT, 
     C           ARAD  , DRAD    )
         ELSE
            CALL RESET( WTDT , NMDIM*KDIM )
         ENDIF
*
         CALL GDHEAT            !" Ǯ主(ʻ)
     M         ( WTDT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL DLNTMP            ! Ǯμ : Ȼ + ܾή
     M           ( WTDT   , 
     I             WDT    , WDPOR  , 
     C             FLAPLA ,
     C             ARAD   , DRAD      )
*
*"          -----------------------< ͶƳ >
*
         IF( ONLIND )THEN
            CALL KDGIND         !" ͶƳͶƳ (vB)
     O         ( WTBTOR, WTBPOR, 
     I           GBLON , GBLAT , GBRAD , 
     I           GDU   , GDV   , GDW   , 
     C           UVFACT, FLAPLA, 
     C           ARAD  , DRAD             )
         ELSE
            CALL RESET( WTBTOR , NMDIM*KDIM )
            CALL RESET( WTBPOR , NMDIM*KDIM )
         ENDIF
*
        CALL KDLIND      !" ͶƳ() 1/Pm B_T, 1/Pm B_S
     M         ( WTBTOR , WTBPOR , 
     I           WBTOR  , WBPOR  , 
     C           PRNDM  , 
     C           FLAPLA , 
     C           ARAD   , DRAD      )
*
*" ---------------------<< INTGR : ʬ >>------------------------
*
        CALL MHTINT
     M         ( WDTOR  , WDPOR  , WDDPOR, WDT   , 
     M           WBTOR  , WBPOR  , 
     I           WTDTOR , WTDPOR , WTDT  , 
     I           WTBTOR , WTBPOR , 
     I           DELT   , ITRUNG , 
     C           FLAPLA , NMO    , 
     C           ARAD   , DRAD             )
*
        CALL MHGENG                !" ʻͤ
     O         ( GDU   , GDV   , GDW   , GDT   , 
     O           GDTOR , GDPOR ,
     O           GBLON , GBLAT , GBRAD ,
     O           GBTOR , GBPOR ,
     I           WDTOR , WDPOR , WDT   , 
     I           WBTOR , WBPOR , 
     C           FLAPLA, UVFACT, 
     C           ARAD  , DRAD                    )
*
      IF ( ITRUNG . LT. IORUNG ) GOTO 8888  !" <--- Runge-Kutta Loop 
*
      CALL MIDIAG      !"  ǽ 
     I     ( IT    , 
     I       GDU   , GDV   , GDW   , GDT   , 
     I       GBLON , GBLAT , GBRAD , 
     C       PRND  , RAYL  , 
     C       ALON  , DLON  , ALAT  , DLAT  , 
     C       ARAD  , DRAD                    )
*
      RETURN
*======================================================================
      ENTRY MHSTRT                      !" ǡκ
     O         ( GDU   , GDV   , GDW   , 
     O           GBLON , GBLAT , GBRAD , 
     M           GDT   , GDTOR , GDPOR ,
     M           GBTOR , GBPOR ,
     C           ALAT  , DLAT  , 
     C           ARAD  , DRAD             )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, 0:KMAX )  !"    
*     REAL       GAV   ( IDIM, JDIM, 0:KMAX )  !"    
*     REAL       GAW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
*     REAL       GBLON ( IDIM, JDIM, 0:KMAX )  !" ʬ
*     REAL       GBLAT ( IDIM, JDIM, 0:KMAX )  !" ʬ
*     REAL       GBRAD ( IDIM, JDIM, 0:KMAX )  !" ưʬ
*
*   [MODIFY]
*     REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !"    
*     REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
*     REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*     REAL       GBTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ뼧 B_T
*     REAL       GBPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ뼧 B_P
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
      CALL STRTV                       !" ǡ
     O         ( GDU   , GDV   , GDW   , 
     M           GDT   , GDTOR , GDPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD                     ) 
*
      CALL KDSTRV                       !" ǡ
     O         ( GBLON , GBLAT , GBRAD , 
     M           GBTOR , GBPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD             ) 
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  MHPARM                        !" ѥ᥿
     O             ( RAYL   , TAU    , PRND   , PRNDM  , 
     O               ONLDYN , ONLTMP , ONLIND           )
*
      IMPLICIT NONE
*
*   [OUTPUT]
      REAL       RAYL                  !" 쥤꡼
      REAL       TAU                   !" ƥ顼
      REAL       PRND                  !" ץɥ
      REAL       PRNDM                 !" ץɥ
      LOGICAL    ONLDYN                !" ׻å(ư)
      LOGICAL    ONLTMP                !" ׻å(٤μ)
      LOGICAL    ONLIND                !" ׻å(ͶƳ)
*
*"         < 1. NAMELIST ɤ߹ >
*
      CALL DPARM
     O       ( RAYL   , TAU    , PRND   , 
     O         ONLDYN , ONLTMP            )
*
      CALL KDPARM
     O       ( PRNDM  , 
     O         ONLIND   )
*
      RETURN
      END
